<?php
// $Id: handler.php,v 1.3.2.6 2007/10/30 13:39:46 owahab Exp $

// Original implementation of locating Drupal root from dursh module by Moshe Weitzman.
define('PHPFREECHAT_DRUPAL_BOOTSTRAP', 'includes/bootstrap.inc');

/**
 * Exhaustive depth-first search to try and locate the Drupal root directory.
 * This makes it possible to run drush from a subdirectory of the drupal root.
 */
function _phpfreechat_locate_root() {
  $path = getcwd();
  // Convert windows paths.
  $path = str_replace('\\','/', $path);
  // Check the current path.
  if (file_exists($path . '/' . PHPFREECHAT_DRUPAL_BOOTSTRAP)) {
    return $path;
  }
  // Move up dir by dir and check each.
  while ($path = _phpfreechat_locate_root_moveup($path)) {
    if (file_exists($path . '/' . PHPFREECHAT_DRUPAL_BOOTSTRAP)) {
      return $path;
    }
  }
  return FALSE;
}

function _phpfreechat_locate_root_moveup($path) {
  if (empty($path)) {
    return FALSE;
  }
  $path = explode('/', $path);
  // Move one directory up.
  array_pop($path);
  return implode($path, '/');
}

/**
 * Bootstrap Drupal.
 */
// Change to Drupal root dir.
chdir(_phpfreechat_locate_root());
// Bootstrap Drupal.
require_once './includes/bootstrap.inc';
drupal_bootstrap(DRUPAL_BOOTSTRAP_SESSION);
// Initialize configuration variables, using values from settings.php if available.
$conf = variable_init(isset($conf) ? $conf : array());
// Add file.inc for various file functions used in phpfreechat
require_once './includes/file.inc';
// Add common.inc to be able to use drupal_get_path later
require_once './includes/common.inc';
// Add user module to handle user permissions in phpfreechat
require_once drupal_get_path('module', 'user') .'/user.module';
// Starting phpfreechat module
require_once drupal_get_path('module', 'phpfreechat') .'/phpfreechat.module';
// Load global params
$params = phpfreechat_load_params();
// We will need to load the current node
if (!function_exists('arg')) {
  // Use HTTP_REFERER to extract the node ID
  $path = str_replace(array($base_url, '/?q='), '', $_SERVER['HTTP_REFERER']);
  // Get the real path from the current request
  require_once './includes/path.inc';
  $args = explode('/', drupal_get_normal_path($path));
  $nid = $args[1];
  $node = db_fetch_object(db_query('SELECT * FROM {node} WHERE nid = %d', $nid));
}
// Prepare params for current node
$params = phpfreechat_prepare_params($params, $node);
// Start/resume a chat room
require_once drupal_get_path('module', 'phpfreechat') .'/phpfreechat/src/phpfreechat.class.php';
$chat = new phpFreeChat($params);
?>
